from distutils.core import setup

pkg = [
      'tagit'
    , 'tagit.controller'
    , 'tagit.controller.actions'
    , 'tagit.datalog'
    , 'tagit.suggestion'
    , 'tagit.suggestion.features'
    , 'tagit.controller.sidebox'
    , 'tagit.model'
    , 'tagit.model.update'
    , 'tagit.view'
    , 'tagit.view.actions'
    , 'tagit.view.dialogues'
    , 'tagit.view.sidebox'
    , 'tagit.external'
    , 'tagit.external.cmap'
    , 'tagit.program'
    ]

pkg_data = {
      'tagit'                   : ['settings.json', 'keybindings.json', 'resources/*', 'resources/30/*', 'resources/dict/*', 'resources/fonts/*']
    , 'tagit.model'             : ['schema/scheme-*']
    , 'tagit.external'          : ['*.kv', 'cmap/license.t']
    , 'tagit.view'              : ['*.kv']
    , 'tagit.view.actions'      : ['*.kv']
    , 'tagit.view.dialogues'    : ['*.kv', 'license.t']
    , 'tagit.view.sidebox'      : ['*.kv']
    , 'tagit.suggestion'        : ['default_model.dat']
    }


setup(
    name='tagit',
    version='1.2',
    description='A tool to edit image keywords',
    long_description=open('README').read(),
    author='Matthias Baumgartner',
    author_email='dev@igsor.net',
    url='http://www.igsor.net/projects/tagit/',
    packages=pkg,
    package_data = pkg_data,
    scripts = ['tagger'],
    license='Free for use',
    requires=('kivy', 'Image', 'pyexiv2', 'sqlite3', 'magic', 'json', 'numpy')
)

## EOF ##
