"""

* Selected images or filter -> show info (num selected, num exported, num visible)
* method (symlink, hardlink, copy) -> drop-down
* keep structure -> checkbox

* Export to target -> choose path (dir picker)



Part of the tagit module.
A copy of the license is provided with the project.
Author: Matthias Baumgartner, 2016

"""
# IMPORTS

# INNER-MODULE IMPORTS
from ...tools import images_export
from ...bindings import Binding
from ..controller import DataController

# EXPORTS
__all__ = ('CSidebox_Image_Export', )

## CODE ##
class CSidebox_Image_Export(DataController):
    """Export images to a directory."""
    def __init__(self, widget, model, settings, parent=None, browser=None):
        super(CSidebox_Image_Export, self).__init__(widget, model, settings, parent)
        self._browser = browser

    def export(self, method, target, structure=False):
        try:
            if method not in ('copy', 'symlink', 'hardlink'):
                raise Exception('Please choose an export method')

            if self._browser.controller is None:
                raise Exception('Internal error')

            images = self._browser.controller.visible()

            if len(images) == 0:
                raise Exception('No images to export')

            images_export(
                images,
                target,
                method,
                keep_structure=structure,
                simulate=False,
                verbose=self.settings.trace('session', 'verbose', False),
                overwrite=True
            )

            self.widget.error('Export complete')

        except Exception, e:
            self.widget.error('Oooos. ' + e.message)

## EOF ##
