"""Status controller.

Part of the tagit module.
A copy of the license is provided with the project.
Author: Matthias Baumgartner, 2016
"""
# imports

# inner-module imports
from controller import Controller

# exports
__all__ = ('CStatus', )


## CODE ##

class CStatus(Controller):
    """
    """
    def __init__(self, widget, settings, parent=None, **kwargs):
        super(CStatus, self).__init__(widget, settings, parent, **kwargs)

        # Results bindings
        self.parent.bind(status=self.on_status_update)
        self.parent.bind(navigation_info=self.on_navigation_update)

    def __del__(self):
        # Release bindings
        self.parent.unbind(status=self.on_status_update)
        self.parent.unbind(navigation_info=self.on_navigation_update)

    def on_status_update(self, status):
        self.widget.update_status(str(status))

    def on_navigation_update(self, pg_first, pg_last, total):
        navi = "{0} - {1} of {2}".format(pg_first, pg_last, total)
        self.widget.update_navigation(navi)

## EOF ##
