
from ..token import Token_SingleValue, Token_SingleValue_Parsed, register_token

class Token_Path(Token_SingleValue):
    def __init__(self):
        super(Token_Path, self).__init__('')
    def display(self):
        return 'Path'
    def get(self):
        return self._value.replace('*', '%')
    @staticmethod
    def from_string(string):
        return Token_Path().update(string)
    @staticmethod
    def match(obj):
        return isinstance(obj, Token_Path)

class Token_Image(Token_SingleValue_Parsed):
    def __init__(self):
        super(Token_Image, self).__init__([])

class Token_Include(Token_Image):
    def display(self):
        return 'R'
    @staticmethod
    def from_string(string):
        return Token_Include().update(string)
    @staticmethod
    def match(obj):
        return isinstance(obj, Token_Include)

class Token_Exclude(Token_Image):
    def display(self):
        return 'E'
    @staticmethod
    def from_string(string):
        return Token_Exclude().update(string)
    @staticmethod
    def match(obj):
        return isinstance(obj, Token_Exclude)

register_token('path', Token_Path)
register_token('include', Token_Include)
register_token('exclude', Token_Exclude)

## EOF ##
