"""

Part of the tagit module.
A copy of the license is provided with the project.
Author: Matthias Baumgartner, 2017
"""
# imports

# inner-module imports
from feature import Feature

# exports
__all__ = ('Hierarchy', )


## code ##

class Hierarchy(Feature):
    # FIXME: Return not aggregated but one per candidate?!
    def is_subset(self, tag): # Is a subset of another candidate
        # tagA subset of tagB: all(tagB in img for img in tagA)
        tag = self.graph.tag_by_name(tag)
        for cand in self.candidates:
            cand = self.graph.tag_by_name(cand) # FIXME
            if cand == tag: continue # FIXME
            # subset if all images of tagA in cand
            if all([img in cand for img in tag]):
                return 1.0
        return 0.0

    def is_superset(self, tag): # Is a superset of another candidate
        # tagA superset of tagB: all(tagA in img for img in tagB)
        tag = self.graph.tag_by_name(tag)
        for cand in self.candidates:
            cand = self.graph.tag_by_name(cand) # FIXME
            if cand == tag: continue # FIXME (eq comparison)
            # subset if all images of tagA in cand
            if all([img in tag for img in cand]):
                return 1.0
        return 0.0

    def disjoint_sets(self, tag): # Number of disjoint sets including tag
        #
        raise NotImplementedError()


## EOF ##
