"""

TODO: Training!

Part of the tagit module.
A copy of the license is provided with the project.
Author: Matthias Baumgartner, 2017
"""
# imports
from operator import mul, add

# inner-module imports
from tagit.basics import unique
from producers import ALL_PRODUCERS, present_all, present_any
from scores import Score

# exports
__all__ = ('suggest_new', )

# params
FEATURES = """
ImageRelated.split_ratio_all
ImageRelated.having
ImageRelated.not_having
ImageRelated.info_all
ImageRelated.freq_tags
ImageRelated.freq_images
""".split()

## code ##

def suggest_new(log, model, images):
    """Suggest new tags for *images*.

    First, a list of suggested tags is collected. Different
    sources can be combined and interact with each other.

    Then, the suggestions are ranked. Different criteria
    produce multiple scores or features. For each suggestion,
    its features are computed, according to which the suggestions
    are ranked.

    """
    suggestions = reduce(add, [producer(model, images) for producer in ALL_PRODUCERS])

    # TODO: log suggestions
    # TODO: no need to log filter, that was already done. However, the suggestions and filter must be correlated!
    # NOTE: images could be restored from model and filters. Candidates could be restored from images and model. i.e. producers(model, (model, filters)) -> candidates. Might be inaccurate (partial history) and a lot of work too (simulation).

    # exclude tags present in all images
    all_tags_lower = map(unicode.lower, present_all(model, images))
    suggestions = [s for s in suggestions if s.lower() not in all_tags_lower]

    # exclude tags present in any image
    #all_tags_lower = map(unicode.lower, present_any(model, images))
    #suggestions = [s for s in suggestions if s.lower() not in all_tags_lower]

    # pruning
    suggestions = unique(suggestions)

    mpath = '/tmp/model_suggest_new' # FIXME!!
    score = Score(mpath, FEATURES, model, suggestions)
    score.prepare()
    return sorted(suggestions, key=score.score)

def train_new(model):
    """
    """
    # s = Score(mpath, FEATUES, model, suggestions)
    # * needs to know feature structure
    # * needs to have model
    # * doesn't need suggestions
    # * doesn't need svm model path
    """
    Score.train(self, data):
        data: {target -> [tags, ...]}
            target: tag which was selected (part of candidates!)
            tags:   list of candidates
            ...:    Additional info such as model, timestamp, history, ...
        qid:  iterate through targets
        rank: target has rank 2, others rank 1
        training data: [(enum, feature(tag))] per tag
        returns: function that stores model given path
    """
    raise NotImplementedError()

## EOF ##
