"""Dialogue which shows some text.
"""
# imports
from kivy.properties import StringProperty
from os.path import join, dirname
from kivy.lang import Builder
from dialogue import Dialogue

# exports
__all__ = ('ErrorDialogue', )

# Load kv
Builder.load_file(join(dirname(__file__), 'dlg_error.kv'))

# Classes
class ErrorDialogue(Dialogue):
    """Dialogue with some text.

    Set the default text as **text**.

    >>> try:
    >>>     ...
    >>> except Exception, e:
    >>>     ErrorDialogue(text=e.message).open()

    """

    text = StringProperty('')

## EOF ##
