"""

Part of the tagit module.
A copy of the license is provided with the project.
Author: Matthias Baumgartner, 2016

"""
# IMPORTS
from kivy.uix.label import Label

# INNER-MODULE IMPORTS
from sidebox import VSidebox
from ...controller.sidebox import CSidebox_Tags_Cursor

# EXPORTS
__all__ = ('VSidebox_Tags_Cursor', )

# LOAD KV

# CLASSES
class VSidebox_Tags_Cursor(Label, VSidebox):
    """List tags of the image under the cursor."""
    def on_widget_change(self, instance, widget):
        self.controller = widget.get_controller(CSidebox_Tags_Cursor, wx=self)

    def update(self, tags):
        self.text = '\n'.join(tags)


## EOF ##
